#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <linux/cdrom.h>
#include <sys/ioctl.h>
#include "sha.h"
#include "base64.h"
#include "jac_cmd.h"
#include "jac_cddb.h"
#include "jac_cdi.h"


/* This function is to retrive a variable value from an XML
 * file. It has to be refined, but for the moment it suffice */
char *getxmlvar(char *s,char *what)
{
	char *ts=NULL;
	char *te=NULL;
	int diff;
	char xmlt[128];

	sprintf(xmlt,"<%s>",what);

	ts=strstr(s,xmlt);
	if (ts==NULL)
		return ts;

	ts=ts+strlen(xmlt);

	sprintf(xmlt,"</%s>",what);

	te=strstr(ts,what);
	if (te==NULL)
		return ts;

	diff=strlen(ts)-strlen(te);
	diff--;

	snprintf(te,diff,"%s",ts);

	return te;
	
}

int trans_cdi_cddb(int last,int cd_fd)
{
	FILE *fpi,*fpo;
	char nomfil[255];
	char *buff=malloc(4096);
	int ntrack=0;
	char *res;
	char titolo[255];

	sprintf( nomfil, "%s/%08lx",dircddb,cddb_discid(last,cd_fd) );
	fpo=fopen(nomfil,"w");	
	if (fpo==NULL)
		return -1;

	sprintf( nomfil, "/tmp/%08lx",cddb_discid(last,cd_fd) );
	fpi=fopen(nomfil,"r");	
	if (fpi==NULL)
		return -2;

	ntrack=0;
	while (fgets(buff,400,fpi)!=NULL) {
		if ((res=getxmlvar(buff,"Title"))) {
			strcpy(titolo,res);
			continue;
		}

		if ((res=getxmlvar(buff,"Artist"))) {
			fprintf(fpo,"#Downloaded from CdIndex\n");
			fprintf(fpo,"DTITLE=%s / %s\n",res,titolo);
			continue;
		}
			
		if ((res=getxmlvar(buff,"Name"))) {
			fprintf(fpo,"TTITLE%01d=%s\n",ntrack++,res);
			continue;
		}
		
	}

	fclose(fpi);
	fclose(fpo);
				
	return 0;	
}

int leggi_te(int cd_fd,int trk,int *lba)
{
 	struct cdrom_tocentry te;

	te.cdte_track=trk;
	te.cdte_format=CDROM_LBA;

	if (ioctl(cd_fd,CDROMREADTOCENTRY,&te)==0) {
		if (te.cdte_format != CDROM_LBA)
			return -1;
		*lba = te.cdte_addr.lba;
	}
	else
		return -1;
	return 0;
}

char *cdi_discid(int last,int cd_fd)
{
	int i=0,lba=0;
	int first=1;
	int offset[100];
	char *id=malloc(50);
	char temp[9];
	unsigned char digest[20], *base64;
	unsigned long size;
	SHA_INFO sha;

	for(i=0;i<100;i++)
		offset[i]=0;

	lba=0;
	if (leggi_te(cd_fd,CDROM_LEADOUT,&lba))
		return (char *)NULL;

	offset[0]=lba+150;

	for(i=first;i<=last;i++) {
		if (!leggi_te(cd_fd,i,&lba))
			offset[i]=lba+150;
	}

	sha_init(&sha);

	sprintf(temp,"%02X",(unsigned char) first);
	sha_update(&sha,(unsigned char *)temp,strlen(temp));
	sprintf(temp,"%02X",(unsigned char) last);
	sha_update(&sha, (unsigned char *)temp, strlen(temp));
	for(i = 0; i < 100; i++) {
		sprintf(temp,"%08X",offset[i]);
		sha_update(&sha,(unsigned char *)temp,strlen(temp));
	}
	sha_final(digest,&sha);
	base64 = rfc822_binary(digest, 20, &size);
	memcpy(id,base64,size);
	id[size] = 0;
	free(base64);

	return id;
}


char *cdi_genurl(int last,int cd_fd)
{
	int i=0,lba=0;
	int first=1;
	int offset[100];
	char s[1024];
	char *url=malloc(1024);
	char temp[9],id[33];
	unsigned char digest[20], *base64;
	unsigned long size;
	SHA_INFO sha;

	for(i=0;i<100;i++)
		offset[i]=0;

	lba=0;
	if (leggi_te(cd_fd,CDROM_LEADOUT,&lba))
		return (char *)NULL;

	offset[0]=lba+150;

	for(i=first;i<=last;i++) {
		if (!leggi_te(cd_fd,i,&lba))
			offset[i]=lba+150;
	}

	sprintf(s,"%d+%d+%d",first,last,offset[0]);

	for (i=first;i<=last;i++) {
		sprintf(s+strlen(s),"+%d",offset[i]);
	}

	sha_init(&sha);

	sprintf(temp,"%02X",(unsigned char) first);
	sha_update(&sha,(unsigned char *)temp,strlen(temp));
	sprintf(temp,"%02X",(unsigned char) last);
	sha_update(&sha, (unsigned char *)temp, strlen(temp));
	for(i = 0; i < 100; i++) {
		sprintf(temp,"%08X",offset[i]);
		sha_update(&sha,(unsigned char *)temp,strlen(temp));
	}
	sha_final(digest,&sha);
	base64 = rfc822_binary(digest, 20, &size);
	memcpy(id,base64,size);
	id[size] = 0;
	free(base64);

	sprintf(url,"?id=%s&tracks=%d&toc=%s",id,last-first+1,s);
	return url;
}


int jac_cdi(int last,int cd_fd)
{
	int sck,i,port,sersock,notfound=0;
	struct sockaddr_in *addr;
	struct hostent *he;
	char s[2048];
	char *in;
	char server[50];
	char buf[200];
	FILE *outfile;
	FILE *fcddb;

	/* As the data file are written using the CDDB format
	 * I search for it using cddb discid */
	sprintf(buf,"%s/%08lx",dircddb,cddb_discid(last,cd_fd));
  	fcddb=fopen(buf,"r");
	if (fcddb!=NULL) {
		fclose(fcddb);
		return 0;
	}

	in=cdi_genurl(last,cd_fd);
	strcpy(server,CDI_SERVER);
	port=80;
	
	he=malloc(sizeof(struct hostent));
	if ((he=gethostbyname(server))==NULL)
		return -1;
	if ((sck=socket(AF_INET,SOCK_STREAM,0))==-1)
		return -2;

	addr=(struct sockaddr_in *) malloc(sizeof(struct sockaddr_in));
	addr->sin_family=AF_INET;
	addr->sin_port=htons(port);
	addr->sin_addr= *((struct in_addr *)he->h_addr);
	bzero(&(addr->sin_zero), 8);
	if (connect(sck, (struct sockaddr *) addr,sizeof(struct sockaddr))==-1) 
		return -3;
	
	sersock=sck;
	snprintf(s,2048,"%s%s HTTP/1.0\r\nHost: %s\r\n\r\n",CDI_SCRIPT,in,CDI_SERVER);
	send(sersock,s,strlen(s),0);
	sprintf( buf, "/tmp/%08lx", cddb_discid(last,cd_fd) );

	outfile = fopen( buf, "w" );
	i=1;
	while (i>0) {
		i=gsock(s,2048,sersock);	
		fprintf( outfile, "%s\n", s );
		if(strncasecmp(s,"THAT CD WAS NOT FOUND",21)==0)
			notfound=1;
	}
	fclose(outfile);
	close(sersock);

	/* I translate XML format to CDDB format. The default may change in 
	 * next version. But as CdIndex DB has so few entrance for the moment
	 * CDDB file format is default. 
	 */
	if (!notfound) {
		if (!trans_cdi_cddb(last,cd_fd))
			agglist(last,cd_fd);
	}
	else return -4;

  return 0;	
}

