#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "mixer.h"
#include "jac.h"
#include "jac_lang.h"
#include "jac_func.h"
#include "jac_cddb.h"

#ifdef HAVE_READLINE_H
#include <readline.h>
#include <history.h>
#define HAVE_READLINE 1
#endif

#ifdef HAVE_READLINE_READLINE_H
#include <readline/readline.h>
#include <readline/history.h>
#define HAVE_READLINE 1
#endif

extern const char *cddb_tbl_result[];
extern const char *cdi_tbl_result[];

void dispsetting(int arr_track[MAXTRACK],int repeat,int ncrazy)
{
	int i;

	fprintf(stdout,PLAYATT);
	for (i=0;i<MAXTRACK && arr_track[i]!=0;i++)
		fprintf(stdout,"%d ",arr_track[i]);
	fprintf(stdout,"\n");
	fprintf(stdout,"Repeat: %s\n",repeat==0 ? "OFF" : "ON");		
	fprintf(stdout,"Crazy : %d\n",ncrazy);
	return;
}

void disp_pl(int arr_track[MAXTRACK])
{
	int i;

	fprintf(stdout,PLAYATT);
	for (i=0;i<MAXTRACK && arr_track[i]!=0;i++)
		fprintf(stdout,"%d ",arr_track[i]);
	fprintf(stdout,"\n");
	return;
}



void getbuff(char *buff,int len)
{
	int i,n,s,sb;
	char *prompt=malloc(64);
	char *buftmp;

	sprintf(prompt,"jac %s> ",VERSION);

#ifdef HAVE_READLINE
	buftmp=readline(prompt);
	if (*buftmp)
		add_history(buftmp);
	strncpy(buff,buftmp,len);
	free(buftmp);
#else
	fprintf(stdout,prompt);
	fgets(buff,len,stdin);
#endif

	for (i=strlen(buff)-1;i>=0;i--) {
		if (*(buff+i)==' ' || *(buff+i)=='\n' || *(buff+i)=='\r' || *(buff+i)=='\t') {
			*(buff+i)='\0';
		}
		else
			break;
	}
	s=0;
	sb=strlen(buff);

	/* Cut double-spaces */
	for (i=0;i<sb-1;i++) {
		if(*(buff+i)==' ' || *(buff+i)==',') {
			if (s==0)
				s=1;
			else {
				for (n=i;n<sb-1;n++)
					*(buff+n)=*(buff+n+1);
				sb--;
				*(buff+sb)='\0';		
				i--;
			}
		}
		else s=0;
	}
}

void check_last(int *last,int cd_fd,int arr_track[MAXTRACK])
{
	/* CD changed? */
	int i;
	if (*last!=last_track(cd_fd)) {
		*last=last_track(cd_fd);
		for (i=0;i<*last;i++)
			arr_track[i]=i+1;
	}
	arr_track[*last]=0;
}

void jacconsole(int cd_fd,int arr_track[MAXTRACK])
{
	char *buff=malloc(256);
	int *status=malloc(sizeof(int));
	int ply,crz,n,i,quit=0;
	int repeat=0,vlm,ncrazy=30;
	int last=last_track(cd_fd);
	*status=0;

	fprintf(stdout,PREMESSAGE,VERSION);
	while (!quit) {
		ply=crz=vlm=0;
		getbuff(buff,255);


		/* Play active playlist */	
		if (strcmp(buff,"play")==0 || strcmp(buff,"p")==0) {
			check_last(&last,cd_fd,arr_track);
			if (arr_track[0]==0) {
				fprintf(stdout,ERRSEQ);
				continue;
			}
			ply=1;
			fprintf(stdout,STRTPLY);
		}

		if (strncmp(buff,"play ",5)==0) {
			if (getseq(buff,arr_track,last,5,1)) {
				arr_track[0]=0;
				continue;
			} else
				ply=1;
		}


		/* version */
		if (strcmp(buff,"version")==0 || strcmp(buff,"V")==0) {
			show_version();
			continue;
		}

		/* info */
		if (strcmp(buff,"info")==0 || strcmp(buff,"i")==0) {
			check_last(&last,cd_fd,arr_track);
			geninfo(cd_fd,2,ply);
			continue;
		}

		/* discid */
		if (strcmp(buff,"discid")==0 || strcmp(buff,"d")==0) {
			fprintf(stdout,"CDDB    Disc ID: %08lx\n",cddb_discid(last,cd_fd));
			fprintf(stdout,"CDIndex Disc ID: %s\n",cdi_discid(last,cd_fd));
			continue;
		}
			
			
		/* cddb */
		if (strcmp(buff,"cddb")==0 || strcmp(buff,"b")==0) {
			if ((i=jac_cddb(cd_fd)))
				fprintf(stdout,"jac::CDDB Result: %s\n",cddb_tbl_result[-i]);
			else
				fprintf(stdout,"Ok!\n");
			continue;
		}

		/* cdindex */
		if (strcmp(buff,"cdindex")==0 || strcmp(buff,"n")==0) {
			if ((i=jac_cdi(last,cd_fd)))
				fprintf(stdout,"jac::CdIndex Result: %s\n",cdi_tbl_result[-i]);
			else
				fprintf(stdout,"Ok!\n");
			continue;
		}


		/* Pause - Resume */
		if (strcmp(buff,"pause")==0 || strcmp(buff,"f")==0) {
			pause_resume(cd_fd);
			continue;
		}
	
		/* Eject */
		if (strcmp(buff,"eject")==0 || strcmp(buff,"e")==0) {
			eject(cd_fd);
			continue;
		}
	
		/* Stop */
		if (strcmp(buff,"stop")==0 || strcmp(buff,"k")==0) {
			fprintf(stdout,OKKAY);
			stop(cd_fd);
			wait(status);
			continue;
		}
	
		/* Help */
		if (strcmp(buff,"help")==0 || strcmp(buff,"h")==0) {
			fprintf(stdout,CONSHELP,VERSION);
			continue;
		}
	

		/* Sort Random */
		if (strcmp(buff,"sortrand")==0 || strcmp(buff,"sr")==0) {
			check_last(&last,cd_fd,arr_track);
			randsort(arr_track);
			disp_pl(arr_track);
			continue;
		}

		/* Sort Back */
		if (strcmp(buff,"sortback")==0 || strcmp(buff,"sb")==0) {
			check_last(&last,cd_fd,arr_track);
			for(n=last,i=0;n>=1;n--)
				arr_track[i++]=n;
			disp_pl(arr_track);
			continue;
		}

		/* Create playlist from 1 to last */
		if (strcmp(buff,"sortnorm")==0 || strcmp(buff,"sn")==0) {
			check_last(&last,cd_fd,arr_track);
			for(n=1,i=0;n<=last;n++)
				arr_track[i++]=n;
			disp_pl(arr_track);
			continue;
		}

		/* Show settings */
		if (strcmp(buff,"set")==0 || strcmp(buff,"g")==0 ) {
			check_last(&last,cd_fd,arr_track);
			dispsetting(arr_track,repeat,ncrazy);
			continue;
		}


		/* Set Playlist */
		if (strncmp(buff,"playlist ",9)==0) {
			if (getseq(buff,arr_track,last,9,1)) {
				arr_track[0]=0;
			} else
				fprintf(stdout,OKKAY);
			continue;
		}

		/* Set Playlist */
		if (strncmp(buff,"y ",2)==0) {
			if (getseq(buff,arr_track,last,2,1)) {
				arr_track[0]=0;
			} else
				fprintf(stdout,OKKAY);
			continue;
		}

		/* Crazy */
		if (strncmp(buff,"crazy ",6)==0) {
			if (*(buff+6))
				ncrazy=getnum(buff+6);
			crz=1;
		}
		if (strncmp(buff,"z ",2)==0) {
			if (*(buff+2))
				ncrazy=getnum(buff+2);
			crz=1;
		}
		if (crz==1) {
			ncrazy=ncrazy/5*5;
			ncrazy=ncrazy==0 ? 30 : ncrazy;
			ncrazy=ncrazy>300 ? 300 : ncrazy;
			fprintf(stdout,STRTCRZ,ncrazy);
		}
		


		/* Volume */
		if (strncmp(buff,"volume ",7)==0) 
			vlm=atoi(buff+7);

		if (strncmp(buff,"v ",2)==0) 
			vlm=atoi(buff+2);

		if (vlm) {
			if (vlm>0 && vlm<128) {
				set_volume(vlm);
				fprintf(stdout,OKKAY);
			} else
				fprintf(stdout,VOLRANGE,get_volume());
			continue;
		}


		/* Toggle repeat */
		if (strcmp(buff,"repeat")==0 || strcmp(buff,"a")==0 ) {
			repeat=repeat==0 ? 1 : 0;
			fprintf(stdout,"Repeat: %s\n",repeat==0 ? "OFF" : "ON");		
			continue;
		}


		/* Quit */
		if (strcmp(buff,"quit")==0 || strcmp(buff,"q")==0) {
			fprintf(stdout,CIAO);
			stop(cd_fd);
			wait(status);
			quit=1;
			break;
		}


		/* Quit & Eject */
		if (strcmp(buff,"exit")==0 || strcmp(buff,"x")==0) {
			fprintf(stdout,CIAO);
			stop(cd_fd);
			wait(status);
			eject(cd_fd);
			quit=1;
			break;
		}


		if (!ply && !crz) {
			fprintf(stdout,"%s\n",buff);
			fprintf(stdout,UNRECOG);
			continue;
		}

		stop(cd_fd);
		wait(status);
		switch (fork()) {
			case -1: /* fork() error */
				fprintf(stderr,ERRFORK);
				exit(1);
			case  0: /* child context */
				if (ply) {
					playlist(repeat,cd_fd,arr_track);
					_exit(0);
				}
				if (crz) {
					crazyplay(cd_fd,arr_track,ncrazy);
					_exit(0);
				}
				break;
			default: /* parent context */
				break;
		}
	}
	return;
}
